package ByteCode;
import DataFlow.*;

// IADD,LADD,FADD,DADD
// ISUB,LSUB,FSUB,DSUB
// IMUL,LMUL,FMUL,DMUL
// IDIV,LDIV,FDIV,DDIV
// IREM,LREM,FREM,DREM
// INEG,LNEG,FNEG,DNEG
// ISHL,LSHL,ISHR,LSHR,IUSHR,LUSHR
// IAND,LAND,IOR,LOR,IXOR,LXOR

public class opARITH extends Instruction
{
  public opARITH(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    switch ( opcode ) {
    case IADD: case ISUB: case IMUL: case IDIV: case IREM:
    case ISHL: case ISHR: case IUSHR:
    case IAND: case IOR:  case IXOR:
      stat.stack.pop(T_INT);
      stat.stack.peek(T_INT);
      break;
    case LADD: case LSUB: case LMUL: case LDIV: case LREM:
    case LAND: case LOR:  case LXOR:
      stat.stack.pop(T_LONG);
      stat.stack.peek(T_LONG);
      break;
    case FADD: case FSUB: case FMUL: case FDIV: case FREM:
      stat.stack.pop(T_FLOAT);
      stat.stack.peek(T_FLOAT);
      break;
    case DADD: case DSUB: case DMUL: case DDIV: case DREM:
      stat.stack.pop(T_DOUBLE);
      stat.stack.peek(T_DOUBLE);
      break;
    case INEG:
      stat.stack.peek(T_INT);
      break;
    case LNEG:
      stat.stack.peek(T_LONG);
      break;
    case DNEG:
      stat.stack.peek(T_DOUBLE);
      break;
    case FNEG:
      stat.stack.peek(T_FLOAT);
      break;
    case LSHL: case LSHR: case LUSHR:
      stat.stack.pop(T_INT);
      stat.stack.peek(T_LONG);
      break;
    default:
      throw new DataFlowException("opARITH", strOpcode);
    }
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
