package ByteCode;
import DataFlow.*;

// LCMP,FCMPL,FCMPG,DCMPL,DCMPG

public class opCOMP extends Instruction
{
  public opCOMP(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    switch ( opcode ) {
    case LCMP:
      stat.stack.pop(T_LONG);
      stat.stack.pop(T_LONG);
      stat.stack.push(Var.vint);
      break;
    case FCMPL: case FCMPG:
      stat.stack.pop(T_FLOAT);
      stat.stack.pop(T_FLOAT);
      stat.stack.push(Var.vint);
      break;
    case DCMPL: case DCMPG:
      stat.stack.pop(T_DOUBLE);
      stat.stack.pop(T_DOUBLE);
      stat.stack.push(Var.vint);
      break;
    default:
      throw new DataFlowException("opCOMP", strOpcode);
    }
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
