package ByteCode;
import DataFlow.*;

// ACONST_NULL
// ICONST_[M1,0,1,2,3,4,5]
// LCONST_[0,1]
// FCONST_[0,1]
// DCONST_[0,1]

public class opCONST extends Instruction
{
  public opCONST(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    switch ( opcode ) {
    case ACONST_NULL:
      stat.stack.push(Var.vnull);
      break;
    case ICONST_M1:
    case ICONST_0: case ICONST_1: case ICONST_2:
    case ICONST_3: case ICONST_4: case ICONST_5:
      stat.stack.push(Var.vint);
      break;
    case LCONST_0: case LCONST_1:
      stat.stack.push(Var.vlong);
      break;
    case FCONST_0: case FCONST_1:
      stat.stack.push(Var.vfloat);
      break;
    case DCONST_0: case DCONST_1:
      stat.stack.push(Var.vdouble);
      break;
    default:
      throw new DataFlowException("opCONST", strOpcode);
    }
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opCONST(int op) {
    super(op);
    length = 1;
  }
}
