package ByteCode;
import DataFlow.*;

// I2L,I2F,I2D
// L2I,L2F,L2D
// F2I,F2L,F2D
// D2I,D2L,D2F
// I2B,I2C,I2S

public class opCONV extends Instruction
{
  public opCONV(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    switch ( opcode ) {
    case I2L: stat.stack.pop(T_INT); stat.stack.push(Var.vlong); break;
    case I2F: stat.stack.pop(T_INT); stat.stack.push(Var.vfloat); break;
    case I2D: stat.stack.pop(T_INT); stat.stack.push(Var.vdouble); break;
    case L2I: stat.stack.pop(T_LONG); stat.stack.push(Var.vint); break;
    case L2F: stat.stack.pop(T_LONG); stat.stack.push(Var.vfloat); break;
    case L2D: stat.stack.pop(T_LONG); stat.stack.push(Var.vdouble); break;
    case F2I: stat.stack.pop(T_FLOAT); stat.stack.push(Var.vint); break;
    case F2L: stat.stack.pop(T_FLOAT); stat.stack.push(Var.vlong); break;
    case F2D: stat.stack.pop(T_FLOAT); stat.stack.push(Var.vdouble); break;
    case D2I: stat.stack.pop(T_DOUBLE); stat.stack.push(Var.vint); break;
    case D2L: stat.stack.pop(T_DOUBLE); stat.stack.push(Var.vlong); break;
    case D2F: stat.stack.pop(T_DOUBLE); stat.stack.push(Var.vfloat); break;
    case I2B: stat.stack.peek(T_INT); break;
    case I2C: stat.stack.peek(T_INT); break;
    case I2S: stat.stack.peek(T_INT); break;
    default:
      throw new DataFlowException("opCONV", strOpcode);
    }
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
