package ByteCode;
import DataFlow.*;

// DUP,DUP_X1,DUP_X2
// DUP2,DUP2_X1,DUP_X2

public class opDUP extends Instruction
{
  public opDUP(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    String here = "opDUP";
    Var v1 = stat.stack.pop(), v2, v3, v4;
    switch ( opcode ) {
    case DUP:
      if ( !v1.isCategory1() )
	throw new DataFlowException(here, strType);
      stat.stack.push(v1);
      stat.stack.push(v1);
      break;
    case DUP_X1:
      v2 = stat.stack.pop();
      if ( !v1.isCategory1() || !v2.isCategory1() )
	throw new DataFlowException(here, strType);
      stat.stack.push(v1);
      stat.stack.push(v2);
      stat.stack.push(v1);
      break;
    case DUP_X2:
      if ( !v1.isCategory1() )
	throw new DataFlowException(here, strType);
      v2 = stat.stack.pop();
      if ( v2.isCategory1() ) {
	v3 = stat.stack.pop();
	if ( !v3.isCategory1() )
	  throw new DataFlowException(here, strType);
	stat.stack.push(v1);
	stat.stack.push(v3);
	stat.stack.push(v2);
	stat.stack.push(v1);
      } else {
	stat.stack.push(v1);
	stat.stack.push(v2);
	stat.stack.push(v1);
      }
      break;
    case DUP2:
      if ( v1.isCategory1() ) {
	v2 = stat.stack.pop();
	if ( !v2.isCategory1() )
	  throw new DataFlowException(here, strType);
	stat.stack.push(v2);
	stat.stack.push(v1);
	stat.stack.push(v2);
	stat.stack.push(v1);
      } else {
	stat.stack.push(v1);
	stat.stack.push(v1);
      }
      break;
    case DUP2_X1:
      v2 = stat.stack.pop();
      if ( v1.isCategory1() ) {
	v3 = stat.stack.pop();
	if ( !v2.isCategory1() || !v3.isCategory1() )
	  throw new DataFlowException(here, strType);
	stat.stack.push(v2);
	stat.stack.push(v1);
	stat.stack.push(v3);
	stat.stack.push(v2);
	stat.stack.push(v1);
      } else {
	if ( !v2.isCategory1() )
	  throw new DataFlowException(here, strType);
	stat.stack.push(v1);
	stat.stack.push(v2);
	stat.stack.push(v1);
      }
      break;
    case DUP2_X2:
      v2 = stat.stack.pop();
      if ( v1.isCategory1() ) {
	if ( !v2.isCategory1() )
	  throw new DataFlowException(here, strType);
	v3 = stat.stack.pop();
	if ( v3.isCategory1() ) {
	  v4 = stat.stack.pop();
	  if ( !v4.isCategory1() )
	    throw new DataFlowException(here, strType);
	  stat.stack.push(v2);
	  stat.stack.push(v1);
	  stat.stack.push(v4);
	  stat.stack.push(v3);
	  stat.stack.push(v2);
	  stat.stack.push(v1);
	} else {
	  stat.stack.push(v2);
	  stat.stack.push(v1);
	  stat.stack.push(v3);
	  stat.stack.push(v2);
	  stat.stack.push(v1);
	}
      } else {
	if ( v2.isCategory1() ) {
	  v3 = stat.stack.pop();
	  if ( !v3.isCategory1() )
	    throw new DataFlowException(here, strType);
	  stat.stack.push(v1);
	  stat.stack.push(v3);
	  stat.stack.push(v2);
	  stat.stack.push(v1);
	} else {
	  stat.stack.push(v1);
	  stat.stack.push(v2);
	  stat.stack.push(v1);
	}
      }
      break;
    default:
      throw new DataFlowException(here, strOpcode);
    }
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opDUP(int op) {
    super(op);
    length = 1;
  }
}
