package ByteCode;
import DataFlow.*;

// GETSTATIC,PUTSTATIC
// GETFIELD,PUTFIELD

public class opFIELD extends Instruction
{
  int cindex;

  public opFIELD(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 3;
    cindex = ReadShort(ofs+1);
  }

  public void Save() {
    super.Save();
    WriteShort(offset+1, cindex);
  }

  public NextState Analyze(State stat) throws DataFlowException {
    String here = "opFIELD";
    if ( SaveState(stat) )
      return null;
    switch ( opcode ) {
    case GETFIELD:
      stat.stack.pop(T_REFER);
    case GETSTATIC:
      stat.stack.push(bc.getFieldVar(cindex));
      break;
    case PUTSTATIC:
    case PUTFIELD:
      if ( !stat.stack.pop().isCompatible(bc.getFieldVar(cindex)) )
	throw new DataFlowException(here, strType);
      if ( opcode == PUTFIELD )
	stat.stack.pop(T_REFER);
      break;
    default:
      throw new DataFlowException("opFIELD", strOpcode);
    }
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opFIELD(int op, int cidx) {
    super(op);
    length = 3;
    cindex = cidx;
  }
}
