package ByteCode;
import DataFlow.*;

// GOTO, GOTO_W

public class opGOTO extends Instruction
{
  Label target;

  public opGOTO(ByteCode bc, int ofs) {
    super(bc, ofs);
    switch ( opcode ) {
    case GOTO:
      length = 3;
      target = bc.lm.RegistLabel(offset + ReadShort(ofs+1));
      break;
    case GOTO_W:
      length = 5;
      target = bc.lm.RegistLabel(offset + ReadInt(ofs+1));
      break;
    }
  }

  public void Adjust(int ofs) {
    super.Adjust(ofs);
    switch ( opcode ) {
    case GOTO:
      if ( InShortRange(target) ) {
	length = 3;
      } else {
	opcode = GOTO_W;
	length = 5;
      }
      break;
    case GOTO_W:
      length = 5;
      break;
    }
  }

  public void Save() {
    super.Save();
    switch ( opcode ) {
    case GOTO:
      WriteShort(offset+1, RelShort(target));
      break;
    case GOTO_W:
      WriteInt(offset+1, RelInt(target));
      break;
    }
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    NextState ns = new NextState(stat);
    ns.push(new Flow(target.getInst(), stat));
    return ns;
  }

  public opGOTO(int op, Label to) {
    super(op);
    if ( op == GOTO )
      length = 3;
    else
      length = 5;
    target = to;
  }
}
