package ByteCode;
import DataFlow.*;

// IINC

public class opIINC extends Instruction
{
  int lindex, amount;

  public opIINC(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 3;
    lindex = ReadByteU(ofs+1);
    amount = ReadByteS(ofs+2);
  }

  public void Save() {
    super.Save();
    WriteByteU(offset+1, lindex);
    WriteByteS(offset+2, amount);
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    stat.local.Read(lindex, T_INT);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
