package ByteCode;
import java.util.*;
import DataFlow.*;

// INVOKEVIRTUAL
// INVOKESPECIAL
// INVOKESTATIC
// INVOKEINTERFACE

public class opINVOKE extends Instruction
{
  int cindex, count;

  public opINVOKE(ByteCode bc, int ofs) throws ByteCodeException {
    super(bc, ofs);
    cindex = ReadShort(ofs+1);
    switch ( opcode ) {
    case INVOKEINTERFACE:
      length = 5;
      count  = ReadByteU(ofs+3);
      if ( ReadByteU(ofs+4) != 0 )
	throw new ByteCodeException("opINVOKE.opINVOKE", "invokeinterface");
      break;
    default:
      length = 3;
      break;
    }
  }

  public void Save() {
    super.Save();
    WriteShort(offset+1, cindex);
    if ( opcode == INVOKEINTERFACE ) {
      WriteByteU(offset+3, count);
      WriteByteU(offset+4, 0);
    }
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    Vector v = bc.getMethodVars(cindex);
    for (int i = v.size()-1; i > 0; i--)
      stat.stack.pop((Var)v.elementAt(i));
    if ( opcode != INVOKESTATIC )
      stat.stack.pop(T_REFER);
    if ( v.elementAt(0) != null )
      stat.stack.push((Var)v.elementAt(0));
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opINVOKE(int op, int cidx, int cnt) {
    super(op);
    if ( op == INVOKEINTERFACE )
      length = 5;
    else
      length = 3;
    cindex = cidx;
    count = cnt;
  }
}
