package ByteCode;
import DataFlow.*;
import Misc.*;

// JSR

public class opJSR extends Instruction
{
  Label target;

  public opJSR(ByteCode bc, int ofs) {
    super(bc, ofs);
    switch ( opcode ) {
    case JSR:
      length = 3;
      target = bc.lm.RegistLabel(offset + ReadShort(ofs+1));
      break;
    case JSR_W:
      length = 5;
      target = bc.lm.RegistLabel(offset + ReadInt(ofs+1));
      break;
    }
    Label retto = bc.lm.RegistLabel(offset + length);
    bc.lm.RegistSubroutine(target, retto);
  }

  public void Adjust(int ofs) {
    super.Adjust(ofs);
    switch ( opcode ) {
    case JSR:
      if ( InShortRange(target) ) {
	length = 3;
      } else {
	opcode = JSR_W;
	length = 5;
      }
      break;
    case JSR_W:
      length = 5;
      break;
    }
  }

  public void Save() {
    super.Save();
    switch ( opcode ) {
    case JSR:
      WriteShort(offset+1, RelShort(target));
      break;
    case JSR_W:
      WriteInt(offset+1, RelInt(target));
      break;
    }
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    stat.Enter(target);
    stat.stack.push(new Var(target));
    ns.push(new Flow(target.getInst(), stat));
    return ns;
  }
}
