package ByteCode;
import DataFlow.*;

// LDC,LDC_W,LDC2_W

public class opLDC extends Instruction
{
  int cindex;

  public opLDC(ByteCode bc, int ofs) {
    super(bc, ofs);
    switch ( opcode ) {
    case LDC:
      length = 2;
      cindex = ReadByteU(ofs+1);
      break;
    case LDC_W:
    case LDC2_W:
      length = 3;
      cindex = ReadShort(ofs+1);
      break;
      
    }
  }

  public void Save() {
    super.Save();
    switch ( opcode ) {
    case LDC:
      WriteByteU(offset+1, cindex);
      break;
    case LDC_W:
    case LDC2_W:
      WriteShort(offset+1, cindex);
      break;
    }
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    stat.stack.push(bc.getConstVar(cindex));
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
