package ByteCode;
import DataFlow.*;

// ILOAD,LLOAD,FLOAD,DLOAD,ALOAD

public class opLOAD extends Instruction
{
  int lindex;

  public opLOAD(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 2;
    lindex = ReadByteU(ofs+1);
  }

  public void Save() {
    super.Save();
    WriteByteU(offset+1, lindex);
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    Var v;
    switch ( opcode ) {
    case ILOAD: v = stat.local.Read(lindex, T_INT); break;
    case LLOAD: v = stat.local.Read(lindex, T_LONG); break;
    case FLOAD: v = stat.local.Read(lindex, T_FLOAT); break;
    case DLOAD: v = stat.local.Read(lindex, T_DOUBLE); break;
    case ALOAD: v = stat.local.Read(lindex, T_RETURN); break;
    default:
      throw new DataFlowException("opLOAD", strOpcode);
    }
    stat.stack.push(v);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opLOAD(int op, int l) {
    super(op);
    length = 2;
    lindex = l;
  }
}
