package ByteCode;
import DataFlow.*;

// ILOAD_[0123]
// LLOAD_[0123]
// FLOAD_[0123]
// DLOAD_[0123]
// ALOAD_[0123]

public class opLOAD2 extends Instruction
{
  public opLOAD2(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    int lindex = (opcode - ILOAD_0) & 3;
    int opkind = (opcode - ILOAD_0) / 4;
    Var v;
    switch ( opkind ) {
    case 0: v = stat.local.Read(lindex, T_INT); break;
    case 1: v = stat.local.Read(lindex, T_LONG); break;
    case 2: v = stat.local.Read(lindex, T_FLOAT); break;
    case 3: v = stat.local.Read(lindex, T_DOUBLE); break;
    case 4: v = stat.local.Read(lindex, T_RETURN); break;
    default:
      throw new DataFlowException("opLOAD2", strOpcode);
    }
    stat.stack.push(v);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opLOAD2(int op) {
    super(op);
    length = 1;
  }
}
