package ByteCode;
import DataFlow.*;

// IALOAD
// LALOAD
// FALOAD
// DALOAD
// AALOAD
// BALOAD
// CALOAD
// SALOAD

public class opLOADA extends Instruction
{
  public opLOADA(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    String here = "opLOADA";
    stat.stack.pop(T_INT);
    Var v1 = Var.getArrayElementVar(stat.stack.pop()), v2;
    switch ( opcode ) {
    case IALOAD: v2 = Var.vint; break;
    case LALOAD: v2 = Var.vlong; break;
    case FALOAD: v2 = Var.vfloat; break;
    case DALOAD: v2 = Var.vdouble; break;
    case AALOAD: v2 = Var.vnull; break;
    case BALOAD: v2 = Var.vbyte; break;
    case CALOAD: v2 = Var.vchar; break;
    case SALOAD: v2 = Var.vshort; break;
    default:
      throw new DataFlowException(here, strOpcode);
    }
    if ( !v1.isSameType(v2) )
      throw new DataFlowException(here, strType);
    stat.stack.push(v1);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opLOADA(int op) {
    super(op);
    length = 1;
  }
}
