package ByteCode;
import DataFlow.*;

// NEWARRAY
// MULTIANEWARRAY

public class opNEWARRAY extends Instruction
{
  int atype;
  int cindex, dim;

  public opNEWARRAY(ByteCode bc, int ofs) {
    super(bc, ofs);
    switch ( opcode ) {
    case NEWARRAY:
      length = 2;
      atype = ReadByteU(ofs+1);
      break;
    case MULTIANEWARRAY:
      length = 4;
      cindex = ReadShort(ofs+1);
      dim    = ReadByteU(ofs+3);
      break;
    }
  }

  public void Save() {
    super.Save();
    switch ( opcode ) {
    case NEWARRAY:
      WriteByteU(offset+1, atype);
      break;
    case MULTIANEWARRAY:
      WriteShort(offset+1, cindex);
      WriteByteU(offset+3, dim);
      break;
    }
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    switch ( opcode ) {
    case NEWARRAY:
      stat.stack.pop(T_INT);
      stat.stack.push(Var.getArrayVar(atype));
      break;
    case MULTIANEWARRAY:
      for (int i = 0; i < dim; i++)
	stat.stack.pop(T_INT);
      stat.stack.push(Var.getArrayVar(bc.getClassVar(cindex), dim));
      break;
    default:
      throw new DataFlowException("opNEWARRAY", null);
    }
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
