package ByteCode;
import DataFlow.*;

// BIPUSH,SIPUSH

public class opPUSH extends Instruction
{
  int value;

  public opPUSH(ByteCode bc, int ofs) {
    super(bc, ofs);
    switch ( opcode ) {
    case BIPUSH:
      length = 2;
      value = ReadByteS(ofs+1);
      break;
    case SIPUSH:
      length = 3;
      value = ReadShort(ofs+1);
      break;
    }
  }

  public void Save() {
    super.Save();
    switch ( opcode ) {
    case BIPUSH:
      WriteByteS(offset+1, value);
      break;
    case SIPUSH:
      WriteShort(offset+1, value);
      break;
    }
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    switch ( opcode ) {
    case BIPUSH: stat.stack.push(Var.vbyte); break;
    case SIPUSH: stat.stack.push(Var.vshort); break;
    default:
      throw new DataFlowException("opPUSH", strOpcode);
    }
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opPUSH(int op, int v) {
    super(op);
    if ( op == BIPUSH )
      length = 2;
    else
      length = 3;
    value = v;
  }
}
