package ByteCode;
import DataFlow.*;
import Misc.*;

// RET

public class opRET extends Instruction
{
  int lindex;

  public opRET(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 2;
    lindex = ReadByteU(ofs+1);
  }

  public void Save() {
    super.Save();
    WriteByteU(offset+1, lindex);
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    // check returnAddresses
    String here = "opRET";
    Var v = stat.local.Read(lindex);
    Label subr = stat.Leave();
    if ( !v.equals(new Var(subr)) )
      throw new DataFlowException(here, "imcompatible returnAddress");
    // return to returnAddresses
    NextState ns = new NextState(stat);
    ns.isRET = true;
    MySet rset = bc.lm.getReturnAddresses(subr);
    if ( rset == null )
      throw new DataFlowException(here, "returnAddress not found");
    for (int i = 0; i < rset.size(); i++)
      ns.push(new Flow(((Label)rset.elementAt(i)).getInst(), stat));
    return ns;
  }
}
