package ByteCode;
import DataFlow.*;

// IRETURN,LRETURN,FRETURN,DRETURN,ARETURN,RETURN

public class opRETURN extends Instruction
{
  public opRETURN(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    switch ( opcode ) {
    case IRETURN: stat.stack.pop(T_INT); break;
    case LRETURN: stat.stack.pop(T_LONG); break;
    case FRETURN: stat.stack.pop(T_FLOAT); break;
    case DRETURN: stat.stack.pop(T_DOUBLE); break;
    case ARETURN: stat.stack.pop(T_REFER); break;
    case RETURN:  break;
    default:
      throw new DataFlowException("opRETURN", strOpcode);
    }
    stat.stack.Flash();
    return new NextState(stat);
  }
}
