package ByteCode;
import DataFlow.*;

// ISTORE,LSTORE,FSTORE,DSTORE,ASTORE

public class opSTORE extends Instruction
{
  int lindex;

  public opSTORE(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 2;
    lindex = ReadByteU(ofs+1);
  }

  public void Save() {
    super.Save();
    WriteByteU(offset+1, lindex);
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    Var v;
    switch ( opcode ) {
    case ISTORE: v = stat.stack.pop(T_INT); break;
    case LSTORE: v = stat.stack.pop(T_LONG); break;
    case FSTORE: v = stat.stack.pop(T_FLOAT); break;
    case DSTORE: v = stat.stack.pop(T_DOUBLE); break;
    case ASTORE: v = stat.stack.pop(T_RETURN); break;
    default:
      throw new DataFlowException("opSTORE", strOpcode);
    }
    stat.local.Write(lindex, v);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opSTORE(int op, int l) {
    super(op);
    length = 2;
    lindex = l;
  }
}
