package ByteCode;
import DataFlow.*;

// ISTORE_[0123]
// LSTORE_[0123]
// FSTORE_[0123]
// DSTORE_[0123]
// ASTORE_[0123]

public class opSTORE2 extends Instruction
{
  public opSTORE2(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    int lindex = (opcode - ISTORE_0) & 3;
    int opkind = (opcode - ISTORE_0) / 4;
    Var v;
    switch ( opkind ) {
    case 0: v = stat.stack.pop(T_INT); break;
    case 1: v = stat.stack.pop(T_LONG); break;
    case 2: v = stat.stack.pop(T_FLOAT); break;
    case 3: v = stat.stack.pop(T_DOUBLE); break;
    case 4: v = stat.stack.pop(T_RETURN); break;
    default:
      throw new DataFlowException("opSTORE2", strOpcode);
    }
    stat.local.Write(lindex, v);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opSTORE2(int op) {
    super(op);
    length = 1;
  }
}
