package ByteCode;
import DataFlow.*;

// IASTORE
// LASTORE
// FASTORE
// DASTORE
// AASTORE
// BASTORE
// CASTORE
// SASTORE

public class opSTOREA extends Instruction
{
  public opSTOREA(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    String here = "opSTOREA";
    Var v1 = stat.stack.pop(); stat.stack.pop(T_INT);
    Var v2 = Var.getArrayElementVar(stat.stack.pop());
    if ( !v1.isSameType(v2) )
      throw new DataFlowException(here, strType);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opSTOREA(int op) {
    super(op);
    length = 1;
  }
}
