package ByteCode;
import DataFlow.*;

// SWAP

public class opSWAP extends Instruction
{
  public opSWAP(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    Var v1 = stat.stack.pop();
    Var v2 = stat.stack.pop();
    if ( !v1.isCategory1() || !v2.isCategory1() )
      throw new DataFlowException("opSWAP", strType);
    stat.stack.push(v1);
    stat.stack.push(v2);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
