package ClassFile;

public interface ClassFileConst
{
  public static final int JAVA_MAGIC = 0xCAFEBABE;

  /*
   * Constant pool tags
   */
  public static final int CONSTANT_Utf8			= 1;
  public static final int CONSTANT_Integer		= 3;
  public static final int CONSTANT_Float		= 4;
  public static final int CONSTANT_Long			= 5;
  public static final int CONSTANT_Double		= 6;
  public static final int CONSTANT_Class		= 7;
  public static final int CONSTANT_String		= 8;
  public static final int CONSTANT_Fieldref		= 9;
  public static final int CONSTANT_Methodref		= 10;
  public static final int CONSTANT_InterfaceMethodref	= 11;
  public static final int CONSTANT_NameAndType		= 12;
  public static final int CONSTANT_Invalid		= -1;

  /*
   * Access and property flags
   */
  public static final int ACC_PUBLIC			= 0x0001;
  public static final int ACC_PRIVATE			= 0x0002;
  public static final int ACC_PROTECTED			= 0x0004;
  public static final int ACC_STATIC			= 0x0008;
  public static final int ACC_FINAL			= 0x0010;
  public static final int ACC_SYNCHRONIZED		= 0x0020;
  public static final int ACC_VOLATILE			= 0x0040;
  public static final int ACC_TRANSIENT			= 0x0080;
  public static final int ACC_NATIVE			= 0x0100;
  public static final int ACC_INTERFACE			= 0x0200;
  public static final int ACC_ABSTRACT			= 0x0400;
  public static final int ACC_STRICT			= 0x0800;

  /*
   * Attribute names
   */
  public static final String ATTR_Code			= "Code";
  public static final String ATTR_Exceptions		= "Exceptions";
  public static final String ATTR_InnerClass		= "InnerClass";
  public static final String ATTR_Synthetic		= "Synthetic";
  public static final String ATTR_SourceFile		= "SourceFile";
  public static final String ATTR_LineNumberTable	= "LineNumberTable";
  public static final String ATTR_LocalVariableTable	= "LocalVariableTable";
  public static final String ATTR_Deprecated		= "Deprecated";

  /*
   * Descriptors
   */
  public static final char DC_BYTE        = 'B';
  public static final char DC_CHAR        = 'C';
  public static final char DC_DOUBLE      = 'D';
  public static final char DC_FLOAT       = 'F';
  public static final char DC_INT         = 'I';
  public static final char DC_LONG        = 'J';
  public static final char DC_CLASS_BEGIN = 'L';
  public static final char DC_CLASS_END   = ';';
  public static final char DC_SHORT       = 'S';
  public static final char DC_BOOLEAN     = 'Z';
  public static final char DC_ARRAY       = '[';
  public static final char DC_VOID        = 'V';
  public static final char DC_ARGS_BEGIN  = '(';
  public static final char DC_ARGS_END    = ')';
}
