package ClassFile;
import java.io.*;

public class infoAttrCode extends infoAttribute
{
  public int max_stack;
  public int max_locals;
  public int pc_start[];	   // exception table
  public int pc_end[];		   //
  public int pc_handler[];	   //
  public infoCPindex catch_type[]; //
  public byte code[];
  public infoAttribute attrs[];

  public infoAttrCode(ClassFile cf, infoCPindex cp, DataInputStream in) throws Exception {
    super(cf, cp, in);
  }

  public void Load(DataInputStream in) throws Exception {
    // max stack, locals
    max_stack = in.readUnsignedShort();
    max_locals = in.readUnsignedShort();
    // bytecode
    code = new byte[in.readInt()];
    in.readFully(code, 0, code.length);
    // exception table
    int length = in.readUnsignedShort();
    pc_start	= new int[length];
    pc_end	= new int[length];
    pc_handler	= new int[length];
    catch_type	= new infoCPindex[length];
    for (int i = 0; i < length; i++) {
      pc_start[i]   = in.readUnsignedShort();
      pc_end[i]	    = in.readUnsignedShort();
      pc_handler[i] = in.readUnsignedShort();
      catch_type[i] = new infoCPindex(in, owner.constant_pool, CONSTANT_Class);
    }
    attrs = new infoAttribute[in.readUnsignedShort()];
    // attribututes (LineNumberTable, LocalVariableTable)
    for (int i = 0; i < attrs.length; i++)
      attrs[i] = infoAttribute.AutoLoad(owner, in);
  }

  public void Adjust() {
    length = 12 + code.length + 8 * pc_start.length;
    attrs = new infoAttribute[0]; // all attributes are deleted
    /*
    for (int i = 0; i < attrs.length; i++) {
      attrs[i].Adjust();
      length += 6 + attrs[i].length;
    }
    */
  }

  public void Save(DataOutputStream out) throws IOException {
    super.Save(out);
    out.writeShort(max_stack);
    out.writeShort(max_locals);
    out.writeInt(code.length);
    out.write(code, 0, code.length);
    out.writeShort(pc_start.length);
    for (int i = 0; i < pc_start.length; i++) {
      out.writeShort(pc_start[i]);
      out.writeShort(pc_end[i]);
      out.writeShort(pc_handler[i]);
      catch_type[i].Save(out);
    }
    out.writeShort(attrs.length);
    for (int i = 0; i < attrs.length; i++)
      attrs[i].Save(out);
  }
}
