package ClassFile;
import java.io.*;

public class infoCPindex implements ClassFileConst
{
  public infoCP cp;
  public int	index;

  public infoCPindex(DataInputStream in) throws IOException {
    Load(in);
  }

  public infoCPindex(DataInputStream in, infoCP[] CPs, int tag) throws Exception {
    Load(in);
    if (index != 0 || tag != CONSTANT_Class) // finally catches all classes
      Resolve(CPs, tag);
  }

  public infoCPindex(int idx, infoCP[] CPs, int tag) throws ClassFileException {
    index = idx;
    Resolve(CPs, tag);
  }

  public void Load(DataInputStream in) throws IOException {
    index = in.readUnsignedShort();
  }

  public void Save(DataOutputStream out) throws IOException {
    out.writeShort(index);
  }

  public void Resolve(infoCP[] CPs, int tag) throws ClassFileException {
    if ( index >= CPs.length || CPs[index].tag != tag )
      throw new ClassFileException("infoCPindex.Resolve", "inconsistent constant pool");
    else
      cp = CPs[index];
  }

  //
  // CodeModify
  //
  public infoCPindex(int idx) {
    index = idx;
  }
}
