package DataFlow;
import java.util.*;
import ByteCode.*;

public class StateCall
{
  private Label top;
  private Hashtable table;

  public StateCall() {
    top = null;
    table = null;
  }

  public StateCall(StateCall ref) {
    top = ref.top;
    if ( top != null ) {
      table = new Hashtable();
      Enumeration enum = ref.table.elements();
      while ( enum.hasMoreElements() ) {
	Object obj = enum.nextElement();
	table.put(obj, obj);
      }
    } else
      table = null;
  }

  //
  // operations
  //
  public void Enter(Label subr) throws DataFlowException {
    String here = "StateCall.add";
    if ( top == null )
      table = new Hashtable();
    else if ( table.containsKey(subr) )
      throw new DataFlowException(here, null);
    top = subr;
    table.put(subr, subr);
  }

  public Label Leave() throws DataFlowException {
    Label curtop = top;
    if ( curtop == null )
      throw new DataFlowException("StateCall.Leave", null);
    top = null;
    table = null;
    return curtop;
  }

  //
  // merge
  //
  public boolean Merge(StateCall ref, boolean isEX) throws DataFlowException {
    String here = "StateCall.Merge";
    if ( top != ref.top ) {
      if ( isEX ) {
	top = null;
	table = null;
	return false;
      } else
	throw new DataFlowException(here, "top level");
    }
    boolean unchanged = true;
    if ( top != null ) {
      Enumeration enum = ref.table.elements();
      while ( enum.hasMoreElements() ) {
	Object obj = enum.nextElement();
	if ( !table.containsKey(obj) ) {
	  unchanged = false;
	  table.put(obj, obj);
	}
      }
    }
    return unchanged;
  }

  //
  // CodeModify
  //
  protected Label getTop() {
    return top;
  }

  //
  // debug
  //
  public void ShowDebug(boolean isRET) {
    System.out.print("call:");
    if ( top != null ) {
      System.out.print(" top(" + top.offset + ")");
      Enumeration enum = table.elements();
      while ( enum.hasMoreElements() )
	System.out.print(" " + ((Label)enum.nextElement()).offset);
    } else if ( isRET )
      System.out.print(" (unknown)");
    System.out.println();
  }
}
